/*
 * Button.cpp
 *
 *  Created on: Mar 21, 2011
 *      Author: lipari
 */

#include "Button.h"
#include "ButtonListener.h"
#include <algorithm>

using namespace std;

template <typename T>
class CallNotify {
	T *ptr;
public:
	CallNotify(T *t) : ptr(t) {}

	template <typename It>
	void operator()(It &i) { i->notify(ptr); }
};

Button::Button(const string &n) : label(n)
{
}

void Button::addListener(ButtonListener &l)
{
	ls.push_back(&l);
}

void Button::notify()
{
	CallNotify<Button> cn(this);
	for_each(ls.begin(),ls.end(), cn);
}

Button::~Button()
{
}
